package com.qmth.boot.core.rateLimit.service;

import com.qmth.boot.core.rateLimit.entity.RateLimitRule;

/**
 * 限流执行服务
 */
public interface RateLimitService {

    /**
     * 根据控制点、访问设备、规则集合执行限流判定
     * 多个规则必须全满足才判定通过
     *
     * @param endpoint
     * @param device
     * @param rules
     * @return
     */
    boolean accept(String endpoint, String device, RateLimitRule... rules);

}
